local dsp = require "luci.dispatcher"
local m, s, o
local zone_opt = {
	name	= "zerotier",
	input	= "ACCEPT",
	forward	= "REJECT",
	output	= "ACCEPT",
	device	= "zt+"
}

local sid = arg[1] or ""

m = Map("zerotier")
m.redirect = dsp.build_url("admin/services/vpn/zerotier/")

if not sid or m.uci:get("zerotier", sid) ~= "zerotier" then
	luci.http.redirect(m.redirect)
	return
end

s = m:section(NamedSection, sid, "zerotier", translatef("ZeroTier instance: %s", sid))
s.addremove = false

o = s:option(Flag, "enabled", translate("Enabled"))

o = s:option(DynamicList, "join", translate("Networks"), translate("Zerotier networks to join"))
o.rmempty = false
o.maxlength = "64"
o.datatype = "hexstring"

function o.validate(self, value, section)
	for q, i in ipairs(value) do
		for w, y in ipairs(value) do
			if i == y and q ~= w then
				m:error_msg(translate("Two or more network values are the same"))
				return false
			end
		end
	end
	return value
end

o = s:option(Value, "port", translate("Port"))
o.datatype = "port"

o = s:option(DummyValue, "node_id", translate("Node Id"), translate("Value is only available after a successful connection"))

function m.on_commit(self)
	luci.util_tlt.enable_vpn_firewall(nil, "zerotier", zone_opt, nil)
end

return m
